//includes
#include  "msp430g2302.h"
#include  "I2C.h"
#include "HYG.h"



/// Funktion zum Lesen der Luftfeuchtigkeit
/*!
       Diese Funktion stellt eine (lesende) Verbindung zum Temperatur/Feuchtesensor
       HYT371 her.
       Aus den Rohdaten der I2C-bertragung wird die relative Feuchte berechnet.
       ber einen "Ping" wird der Messvorgang im Feuchtesensor gestartet.
       Nach einer Bearbeitungszeit knnen neue Werte fr Temperatur und Feuchte
       aus dem Sensor gelesen werden.

       
 */

void ReadHygTemp(char* datensatz)
{
  
  char raw = 0;
  
  unsigned char rxdata[4] = {
    
    0x00, //2 Status bits + 6 MSB Kapazittswert
    0x00, //8 LSB Kapazittswert
    
    0x00, //8 MSB Temperaturwert
    0x00 //6 LSB Temperaturwer
  };
  
  TI_USI_I2CSelect(HYG_ADDR);   //ber ein ACK-Request wird die Messung im Sensor ausgelst
  
  //__delay_cycles(10000);      //Nach einer Wartezeit stehen die neuen Werte zum Auslesen bereit
  

  __disable_interrupt();
  TI_USI_I2CRead(HYG_ADDR,4,0,rxdata);
  __bis_SR_register(LPM0_bits+GIE);
  
  
    //Luftfeuchteberechnung und schreiben in datensatz
    raw = 0x3FFF & (rxdata[0] << 8 | rxdata[1]); //2 Bytes mit Kapazittswerten werden zusammengefhrt und die 2 Statusbits entfernt  
    raw =  (char)((100.0/16384) *raw);           //Berechnung des der Luftfeuchte [%]
    datensatz[0] = raw;                         //! in das bergebene Datenfeld schreiben  
    
    
    //Temperaturberechnung und schreiben in datensatz
    rxdata[3] = rxdata[3] & 0x3F;           //2 least significant Bits maskieren
    raw = rxdata[2] << 6 | rxdata[3];          //
    raw = (char) (165.0/16384*raw-40);         //Berechnen
    datensatz[1] = raw;                       //! in das bergebene Datenfeld schreiben  

    
 
  
}