

//includes
#include "I2C.h"
#include  "msp430g2302.h"



//******************************************************************
//Funktionen
//******************************************************************

/// InitI2C
/*!
       Universal Serial Interface (USI) initilisieren und I2C Datenraten
       auf ca. 100kHz festlegen.
 */
void InitI2C(void)
{
  
  TI_USI_I2C_MasterInit(USIDIV_7+USISSEL_2+USICKPL, StatusCallback);
}





/// CheckI2CSlaves
/*!
     Jeder I2CTeilnehmer wird auf seine Anwesenheit berprft
     Wird ein Teilnehmer nicht gefunden, stoppt das Programm hier
 */

void  CheckI2CSlaves(void)
{
  
   
  while( TI_USI_I2CSelect(RTC_ADDR) ){}       //Endlosschleife falls I2C Slave nicht gefunden wurde 
  
  while( TI_USI_I2CSelect(LCD_ADDR) ){}       //Endlosschleife falls I2C Slave nicht gefunden wurde

  while( TI_USI_I2CSelect(HYG_ADDR) ){}        //Endlosschleife falls I2C Slave nicht gefunden wurde

  while( TI_USI_I2CSelect(EEPROM_ADDR) ){}        //Endlosschleife falls I2C Slave nicht gefunden wurde

    
} 
  

int StatusCallback(unsigned char c)
{
 return TI_USI_EXIT_LPM;                       // exit active for next transfer
}
